/*       cmds_4th.h

         Command definitions for portable Forth compiler.

         Copyright (c) HanSoft 1994,2006
         All Rights Reserved.
*/

#ifndef _CMD_4TH_H
#define _CMD_4TH_H

#define NOOP       0
#define CELLD      0
#define EXECUTE    1
#define CR         2
#define SPACES     3
#define EMIT       4
#define PRINT      5
#define DOT        6
#define FETCH      7
#define STORE      8
#define CATCH      9

#define CAUGHT    10
#define PLUS      11
#define MINUS     12
#define MUL       13
#define DIV       14
#define MOD       15
#define SWAP      16
#define DUP       17
#define OVER      18
#define ROT       19

#define DROP      20
#define EQ        21
#define LT        22
#define GT        23
#define NE        24
#define INVERT    25
#define LT0       26
#define GT0       27
#define BRANCH0   28
#define BRANCH    29

#define FETCHC    30
#define AND       31
#define OR        32
#define XOR       33
#define SHIFT     34
#define ABS       35
#define NEGATE    36
#define QUIT      37
#define MIN       38
#define MAX       39

#define RPUT      40
#define RGET      41
#define RCOPY     42
#define NE0       43
#define EQ0       44
#define ACCEPT    45
#define HEX       46
#define OCTAL     47
#define DECIMAL   48
#define RPFETCH   49

#define SPFETCH   50
#define THROW     51
#define INC       52
#define DEC       53
#define ARGS      54
#define ARGN      55
#define LEFT2     56
#define RIGHT2    57
#define LITERAL   58
#define QDO       59

#define DO        60
#define LOOP      61
#define PLOOP     62
#define LEAVE     63
#define FCLOSE    64
#define FOPEN     65
#define USE       66
#define ADDSTORE  67
#define SLASHMOD  68
#define STARSLSH  69

#define STSLHMOD  70
#define EXIT      71
#define RCOPY3    72
#define DOTR      73
#define NUMBER    74
#define VARIABLE  75
#define RANDOM    76
#define TRAILING  77
#define CALL      78
#define REFILL    79

#define CFETCH    80
#define CSTORE    81
#define TYPE      82
#define FILL      83
#define COUNT     84
#define CMOVE     85
#define PLACE     86
#define OMIT      87
#define PARSE     88
#define LSHARP    89

#define SHARP     90
#define RSHARP    91
#define SHARPS    92
#define SIGN      93
#define HOLD      94
#define TO        95
#define VALUE     96
#define TIME      97
#define STRINGD   98
#define SQUOTE    99

#define PAUSE    100
#define VECTOR   101
#define ENVIRON  102
#define PLITERAL 103
#define FSEEK    104
#define FTELL    105

/* ranges */
#define LastWord4th  FTELL
#define LastMsg4th   M4CABORT

/* flags */
#define F_T        1L
#define F_F        0L

/* file modes */
#define F4_READ      1L
#define F4_WRITE     2L
#define F4_APPND     4L
#define F4_PIPE      8L

/* devices */
#define STD4IN       0L
#define STD4OUT      1L

/* header */
#define Version4th   0x35A
#define App4th       0L

/* compiler */
#define LINKSIZ      64
#define SYMLEN       16

/* interpreter */
#define STACKSIZ     512
#define TIBSIZ       256
#define PADSIZ       512
#define DOTSIZ        64
#define RNDMASK    32767
#define MAXDEVS        8
#define PIPEWAIT 102400L

/* variables and environs */
#define SYS4TH   3
#define VAR4TH  10
#define ENV4TH   5

#define VHI      0
#define VFIRST   1
#define VLAST    2
#define VCIN     3
#define VCOUT    4

#define VBASE    5
#define VIN      6
#define VOUT     7
#define VTIB     8
#define VTIBS    9

/* load+save */
#define HMASK   UCHAR_MAX
#define HBITS   CHAR_BIT
#define HNTINY  SCHAR_MAX
#define HNSMALL SHRT_MAX
#define HSPOS   0
#define HSNEG   1
#define HCCELL  0
#define HCSIGN  1
#define HCBYTE  2
#define HCSHRT  4
#define HCZERO  8
#define HCONE  16

/* generation */
#define UNITSLINE 9
#define DICTSLINE 3

/* no not change */
#define TIB    0
#define PAD    TIBSIZ
#define STRTOP ((TIBSIZ+PADSIZ)-DOTSIZ)
#define S0     0
#define R0     (STACKSIZ-1)

#endif


